/*++

Copyright (C) 2002 - 2004 SCM Microsystems Inc.

Module Name:

	INTERFACE.H

Abstract: These are used to talk with the Firmware
--*/
#ifndef _INTERFACE_H_
#define _INTERFACE_H_

//
// Command Definitions
//
#define	CMD_START		0x40
#define	CMD_WRITE_BYTE	0x41
#define	CMD_READ_BYTE	0x42
#define	CMD_POWER_DOWN	0x43

//
// Status Related definitions.
//
#define	STS_BSY			0x80
#define	STS_ERR			0x01
#define	STS_DRQ			0x08


//
// Structure Definitions.

// Structure for PCDM registers

typedef struct _PCDM_REGISTERS
{
	u_char DummyReg0;
	u_char DataReg1;
	u_char DataReg2;
	u_char DataReg3;
	u_char DataReg4;
	u_char DataReg5;
	u_char DummyReg6;
	u_char CmdStatusReg;
	u_char DummyReg8;
	u_char DummyReg9;
	u_char DummyRegA;
	u_char DummyRegB;
	u_char DummyRegC;
	u_char DummyRegD;
	u_char DeviceControlReg;
	u_char DummyRegF;

} PCDM_REGISTERS, *PPCDM_REGISTERS;

#pragma pack(1)
//
// Power On Structure
//
typedef struct _SCARD_POWERON_PARAMS
{
	u_char byResetType;
	u_char byResetTime;

} SCARD_POWERON_PARAMS ,*PSCARD_POWERON_PARAMS;

#endif // _INTERFACE_H_

// end of file



