#ifndef _PROTOS_H_
#define _PROTOS_H_

// scr241_main.c
#include "includes.h"

dev_link_t *Driver_Attach(
		void
		);

void Driver_Detach(
		dev_link_t 		*pDeviceLink
		);

ssize_t IFDHRead(
	 	struct file 		*file,
		char 			*pucRxBuffer,
		size_t 			count,
		loff_t 			*loc
		);

DWORD LocalRead(
		char 			*pucRxBuffer,
		size_t 			count
		);

ssize_t IFDHWrite(
		struct file 		*file,
		const char 		*pucTxBuffer,
		size_t 			count,
		loff_t 			*loc
		);

ssize_t LocalWrite(
		const char 		*pucTxBuffer,
		size_t 			count
		);


int	IFDHIoctl(
		struct inode 		*inode,
		struct file 		*file,
		u_int 			cmd,
		u_long 			arg
		);

int	IFDHOpen(
		struct inode 		*inode,
		struct file 		*file
		);

int	IFDHClose(
		struct inode 		*inode,
		struct file 		*file
		);

void 	printdummy(
		char 			*dbg_msg, ...
		);

void	Driver_Release(
		u_long 			arg
		);

void 	Driver_IrqHandler(
		int 			irq,
		void 			*pDev,
		struct pt_regs 		*regs
		);

void 	WaitEvent(
		void
		);

void 	SetEvent(
		void
		);

// PcdmHdlr.c
NTSTATUS
IFDGetCardStatus (
		PDEVICE_EXTENSION 	pDeviceExtension
		);

void tqGetCardStatus( void *arg);

void SetEventWait( void *arg );

BOOLEAN
PcmciaIrqServiceRoutine (
        	PDEVICE_EXTENSION 	pDeviceExtension
        	);

DWORD PcdmCheckRegistry(
		PDEVICE_EXTENSION 	pDeviceExtension,
		PUCHAR 			pucInBuffer
		);

int Event_Handler(
		event_t 		event,
		int 			priority,
		event_callback_args_t 	*args
		);

void cs_error(
		client_handle_t 	handle,
		int 			func,
		int 			ret
		);

void Driver_SetIOBase(
		DEVICE_EXTENSION 	*pDeviceExtension,
		u_long 			iobase
		);

NTSTATUS Driver_InitLocal(
		DEVICE_EXTENSION  	*pDeviceExtension
		);

void CardStatusCheck(
		void  			*arg
		);

// PcdmRdWr.c
NTSTATUS PcdmWrite (
		DEVICE_EXTENSION	*pDeviceExtension,
		PUCHAR			pData,
		DWORD			dwDataLen
		);

NTSTATUS PcdmWriteRevA (
        	DEVICE_EXTENSION        *pDeviceExtension,
        	PUCHAR                  pData,
        	DWORD                   dwDataLen
        	);

NTSTATUS PcdmWriteRevC (
        	PDEVICE_EXTENSION       pDeviceExtension,
	        PUCHAR                  pData,
		DWORD                   dwDataLen
        	);


NTSTATUS PcdmRead (
		DEVICE_EXTENSION 	*pDeviceExtension,
		PUCHAR			pData,
		PDWORD			pdwDataLen
		);

NTSTATUS PcdmReadRevA(
        DEVICE_EXTENSION *pDeviceExtension,
        u_char *        pData,
        PDWORD          pdwDataLen
        );

NTSTATUS PcdmReadRevC (
        PDEVICE_EXTENSION       pDeviceExtension,
        u_char *                pData,
        PDWORD                  pdwDataLen
        );

NTSTATUS PcdmWaitForDeviceReady(
		DEVICE_EXTENSION 	*pDeviceExtension
		);

// thread.c
void PcdmCardStatusThread(
		kthread_t 		*kthread
		);

void kthread_launcher(
		void 			*data
		);

void start_kthread(
		void 			(*func)(kthread_t *),
		kthread_t 		*kthread
		);

void stop_kthread(
		kthread_t 		*kthread
		);

void init_kthread(
		kthread_t 		*kthread,
		char 			*name
		);

void exit_kthread(
		kthread_t 		*kthread
		);

// ifd.c

NTSTATUS
IFDPCCardDownloadStart (
		PDEVICE_EXTENSION pDeviceExtension,
	    PUCHAR pBuffer
    	);

NTSTATUS IFDPerformPCCardDownLoad(
		PDEVICE_EXTENSION		pDeviceExtension,
		PUCHAR					pBuffer
		);

void IFDPerformPCCardErase(
		PDEVICE_EXTENSION		pDeviceExtension
		);
			
NTSTATUS
IFDGetInterfaceDetails (
		PDEVICE_EXTENSION		pDeviceExtension
		);
		
NTSTATUS 
IFDSetTransportMechanism (
		PDEVICE_EXTENSION 		pDeviceExtension
		);

#endif
// End of file
