/*++
 *	SCR24x USB Smart Card Reader Driver Kernel module
 *  Copyright (C) 2005-2006  TL Sudheendran(tlsudheendran@scmmicro.co.in)

 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.

 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.

 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 *	SCM Microsystems  Inc., hereby disclaims all copyright interest in the
 *	library scr33x.o  written by TL Sudheendran


	Module		:	intrface.h

	Author		:	SCM Microsystems

	Development History :

		Date		Version No.		Changes
		_______________________________________________
		02 Feb, 2004	2.0.1		Initial Versions
		30 Mar, 2004	3.0.1		Added support for suspend, resume
									under event handler.
		22 Nov, 2004	3.1.1		TTP issues 1359,1360
		25 Feb, 2005	3.2.1		Added support for Linux 2.6.x; TTP 1410, 2139
		17 May, 2005	4.1.1		Removed known limitations regarding surprise
									removal; Added LGPL License agreement


--*/
#ifndef _INTERFACE_H_
#define _INTERFACE_H_

//
// Command Definitions
//
#define	CMD_START		0x40
#define	CMD_WRITE_BYTE	0x41
#define	CMD_READ_BYTE	0x42
#define	CMD_POWER_DOWN	0x43

//
// Status Related definitions.
//
#define	STS_BSY			0x80
#define	STS_ERR			0x01
#define	STS_DRQ			0x08


//
// Structure Definitions.

// Structure for PCDM registers

typedef struct _PCDM_REGISTERS
{
	u_char DummyReg0;
	u_char DataReg1;
	u_char DataReg2;
	u_char DataReg3;
	u_char DataReg4;
	u_char DataReg5;
	u_char DummyReg6;
	u_char CmdStatusReg;
	u_char DummyReg8;
	u_char DummyReg9;
	u_char DummyRegA;
	u_char DummyRegB;
	u_char DummyRegC;
	u_char DummyRegD;
	u_char DeviceControlReg;
	u_char DummyRegF;

} PCDM_REGISTERS, *PPCDM_REGISTERS;

#pragma pack(1)
//
// Power On Structure
//
typedef struct _SCARD_POWERON_PARAMS
{
	u_char byResetType;
	u_char byResetTime;

} SCARD_POWERON_PARAMS ,*PSCARD_POWERON_PARAMS;

#endif // _INTERFACE_H_

// end of file



